if (not Numen) then return; end

local Numen = Numen;

local AceOO = AceLibrary("AceOO-2.0")

Numen.PopButton = AceOO.Class("AceEvent-2.0");

local _G = getfenv(0)

function Numen.PopButton.prototype:init(parent, type, spellName, spellArgs)
	Numen.PopButton.super.prototype.init(self);
	
	self.parent = parent;
	self.gIndex = spellArgs.gIndex;
	self.spellID = spellArgs.spellID;
	self.order = spellArgs.order;
	
	self.button = CreateFrame("CheckButton", "Numen"..type.."Button"..self.gIndex, parent.button, "SecureAnchorUpDownTemplate,SecureActionButtonTemplate,ActionButtonTemplate");
	self.button:SetWidth(36);
	self.button:SetHeight(36);
	self.button.texture = self.button:CreateTexture(nil, "BACKGROUND");
	self.button.texture:SetAllPoints(self.button);
	self.button.texture:SetTexture(GetSpellTexture(spellName));
	self.button:SetCheckedTexture("");
	self.button:SetNormalTexture("");
	self:ApplyStyle();
	self.button.texture:SetPoint("TOPLEFT", self.button, "TOPLEFT", 3, -3);
	self.button.texture:SetPoint("BOTTOMRIGHT", self.button, "BOTTOMRIGHT",  -3, 3);
	self.button.texture:SetTexCoord(0.08, 0.92, 0.08, 0.92);
	self.button:SetAttribute("*type1", "spell");
	self.button:SetAttribute("spell", spellName);
	self.button.Spell = spellName;
	self.button:SetAttribute("onmouseupbutton", "mup");
	self.button:SetAttribute("*childstate-mup", self.gIndex);
	self.button:SetAttribute("shift-childstate-mup", ATTRIBUTE_NOOP);
	self.button:SetAttribute("anchorchild", parent.frame);
	self.button:SetAttribute("showstates", tostring(parent.index));
	parent.button:SetAttribute("spell-"..self.gIndex, spellName);
	parent.frame:SetAttribute("statemap-anchor-"..self.gIndex, tostring(self.gIndex));
	Numen.root:SetAttribute("addchild", self.button);
	parent.statestr = parent.statestr..self.gIndex..":"..self.gIndex..";";
	self.button.spellID = self.spellID;
	self.button:SetAttribute("order", self.order);
	self.button:SetScript("OnEnter", function(b) Numen:ShowTooltip(b); end);
	self.button:SetScript("OnLeave", function() Numen:HideTooltip(); end);
--[[
	-- Toggle/Reorder frame
	self.button.handle = CreateFrame("Button", self.button:GetName().."Handle", self.button);
	self.button.handle:SetAllPoints(self.button);
	self.button.handle.texture = self.button.handle:CreateTexture();
	self.button.handle.texture:SetTexture(0, 1, 0, 0);
	self.button.handle.texture:SetAllPoints(self.button);
	self.button.handle:RegisterForClicks("LeftButtonUp");
	self.button.handle:EnableMouse(false);
--]]
	self.button.cooldown = _G[self.button:GetName().."Cooldown"];
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN", "ButtonEventHandler")
end

function Numen.PopButton.prototype:UpdateLayout(isVert, isRtDn, x, y)
	if (isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("LEFT", self.parent.button:GetName(), "RIGHT", x, y);
	elseif (isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("RIGHT", self.parent.button:GetName(), "LEFT", x, y);
	elseif (not isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("TOP", self.parent.button:GetName(), "BOTTOM", x, y);
	elseif (not isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("BOTTOM", self.parent.button:GetName(), "TOP", x, y);
	end
	self.button:SetAlpha(Numen.db.profile.confPopAlpha);
	self.button:SetScale(Numen.db.profile.confPopScale);
end

function Numen.PopButton.prototype:ApplyStyle()
	local frame = CreateFrame("Frame", self.button:GetName().."DL", self.button);
	frame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 1, edgeFile = "", edgeSize = 0, insets = {left = 0, right = 0, top = 0, bottom = 0},})
	frame:SetBackdropColor(0, 0, 0, 0.6)
	frame:SetAllPoints(self.button)
	frame:SetFrameLevel(0)
end

function Numen.PopButton.prototype:UpdateCooldown()
	if (self.button.spellID) then
		local start, duration, enable = GetSpellCooldown(self.button.spellID, BOOKTYPE_SPELL)
		CooldownFrame_SetTimer(self.button.cooldown, start, duration, enable)
	end
end

function Numen.PopButton.prototype:ButtonEventHandler(e)
	if (event == "ACTIONBAR_UPDATE_COOLDOWN") then
		self:UpdateCooldown();
	end
end
